// This file is a part of the Framsticks GDK library.
// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
// Refer to http://www.framsticks.com/ for further information.

#ifndef _NEUROCLSOBJECT_H_
#define _NEUROCLSOBJECT_H_

#include "modelparts.h"
#include "neurolibrary.h"
#include "extvalue.h"

extern ParamEntry neuroclass_paramtab[];

class NeuroClassLibObject
{
NeuroLibrary& lib() {return NeuroLibrary::staticlibrary;}
  public:
Param param,classparam;
NeuroClass invalid;
NeuroClass *cls;
long current;
NeuroClassLibObject();
void selectClass(int i);
static int* convertVectorData(const SString& s);
#define STATRICKCLASS NeuroClassLibObject
PARAMSETDEF(current);
PARAMGETDEF(count) {arg1->setInt(lib().getClassCount());}
PARAMPROCDEF(p_findclass);
PARAMPROCDEF(p_getclass);
#undef STATRICKCLASS
};

class NeuroClassExt: public NeuroClass
{
  public:
#define STATRICKCLASS NeuroClassExt
PARAMSETDEF(glyph);
PARAMGETDEF(glyph);
PARAMGETDEF(props);
PARAMGETDEF(summary) {arg1->setString(getSummary());}
#undef STATRICKCLASS
static void makeStaticObject(ExtValue *ret,NeuroClass *cl);
};

#endif







